Attribute VB_Name = "ArcFunctions"
Dim FSO As New FileSystemObject
Public Function CreateArchive(Files As String, Output As String, Optional Upassword As String)
    frmMain.action.Clear
    Temp = Left(Output, Len(Output) - 4)
    frmMain.action.AddItem "-------Begin Report-------"
    frmMain.action.AddItem "Process Started At " & Format(Now(), "Long Time")
    
    frmMain.action.AddItem "Creating Archive:"
    Close
    Set tFile = FSO.CreateTextFile("C:\List.txt", True)
    Files = Files & Chr(0) & "C:\list.txt"
    Dim File() As String
    File = Split(Files, Chr(0))
    For x = 0 To UBound(File()) - 1
        tFile.WriteLine Right(File(x), Len(File(x)) - InStrRev(File(x), "\"))
    Next x
    
    tFile.Close
    Open Output For Binary Access Write Lock Read Write As #1
        Dim MainHeader As Archeader
        Dim curFileHeader As FileHeader
        Dim enc As New clsBlowfish
        If Len(Upassword) = 0 Or Upassword = "[None]" Then
        
            MainHeader.Passworded = 0
            MainHeader.password = ""
        Else
            MainHeader.password = enc.EncryptString(Upassword)
            MainHeader.Passworded = Len(MainHeader.password)
            For x = 1 To 10
                If Rnd(1) < (1 / 3) Then
                    MainHeader.validity = MainHeader.validity & Chr(Int(Rnd * 25) + 1 + Asc("a"))
                ElseIf Rnd(1) > (1 / 3) And Rnd(1) < (2 / 3) Then
                    MainHeader.validity = MainHeader.validity & Chr(Int(Rnd * 25) + 1 + Asc("A"))
                Else
                    MainHeader.validity = MainHeader.validity & Chr(Int(Rnd * 9) + 1 + Asc("0"))
                End If
            Next x
            MsgBox "Your Validity Check is: " & MainHeader.validity & vbCrLf & "Be Sure to remember this. As it will be required to retrieve lost passwords"
            MainHeader.validity = enc.EncryptString(MainHeader.validity)
            
        End If
        MainHeader.Version = "ARC 5"
        MainHeader.DateCreated = Format(Now(), "MM/DD/YY")
        MainHeader.NumberOfFiles = UBound(File) + 1
        frmMain.action.AddItem "Writing the Main Header File"
        Put #1, , MainHeader
        For x = 0 To UBound(File)
             
            frmMain.action.AddItem "Writing the Header File for: " & Right(File(x), Len(File(x)) - InStrRev(File(x), "\"))
            endofheaders = ArcHeaderSize + MainHeader.Passworded + Len(MainHeader.validity)
            curFileHeader.FileLength = FileLen(File(x))
            endofheaders = endofheaders + FileHeaderSize + Len(File(x))
            curFileHeader.FileName = Mid(File(x), InStrRev(File(x), "\") + 1, Len(File(x)) - InStrRev(File(x), "\"))
            Put 1, , curFileHeader
            
        Next x
        Dim data() As Byte
        For x = 0 To MainHeader.NumberOfFiles - 1
            ReDim data(FileLen(File(x)))

            Open File(x) For Binary Access Read Lock Read Write As #2
                 
                frmMain.action.AddItem "Getting the data from: " & Right(File(x), Len(File(x)) - InStrRev(File(x), "\"))
                Get #2, , data()
            frmMain.action.AddItem "Now writing the data..." & Str(LOF(2)) & "bytes"
            Close #2
             
            
            Put #1, , data()
        Next x
        
    Close
    Kill "C:\List.txt"
    frmMain.action.AddItem "Process Ended At " & Format(Now(), "Long Time")
     
    frmMain.action.AddItem "-------End of Report-------"
    frmMain.action.Selected(frmMain.action.ListCount - 1) = True
    frmMain.action.SetFocus
End Function

Public Function ExtractArchive(ArcPath As String, Optional filesToExtract As String = "")
    Dim enc As New clsBlowfish
    frmMain.action.Clear
    Temp = Left(ArcPath, Len(ArcPath) - 4)

     
    frmMain.action.AddItem "-------Begin Report-------"
    frmMain.action.AddItem "Process Started  At " & Format(Now(), "Long Time")
    'Dim FSO As New FileSystemObject
    
    Dim MainHeader As Archeader
    Dim fHeader() As FileHeader
    Dim File() As String
    Dim arcname As String
    arcname = Right(ArcPath, Len(ArcPath) - InStrRev(ArcPath, "\"))
    arcname = Left(arcname, Len(arcname) - 4)
     
    frmMain.action.AddItem "Extracting Archive"
    If filesToExtract <> "" Then DeleteArchive = False
    File = Split(filesToExtract, Chr(0))
    Open ArcPath For Binary Access Read Lock Read Write As #1
         
        frmMain.action.AddItem "Reading ArcHeader"
        Get 1, , MainHeader
        If MainHeader.Passworded Then
            frmLogin.Show (vbModal)
            If Pass <> enc.DecryptString(MainHeader.password) Then
                MsgBox "Incorrect Password, Aborting Operation", vbOKOnly, "Cannot Open File"
                frmMain.action.Clear
                frmMain.action.AddItem "Opening File Failed Due To Invalid Password"
                Exit Function
            End If
        End If
        If MainHeader.Version <> "ARC 5" Then
            MsgBox "Cannot open the file, either it has been corrupted or is the wrong format.", vbOKOnly, "Invalid File"
            frmMain.action.Clear
            frmMain.action.AddItem "Extracting File Failed Due To Invalid File Format"
            Exit Function
        End If
        ReDim fHeader(0 To MainHeader.NumberOfFiles - 1)
         
        frmMain.action.AddItem "Reading File Headers"
        For x = 0 To UBound(fHeader)
            Get 1, , fHeader(x)
        Next x
         
        frmMain.action.AddItem "Detected " & Trim(Str(UBound(fHeader) + 1)) & " Files"
        
        If FSO.FolderExists(Left(ArcPath, InStrRev(ArcPath, "\")) & "\Extracted Files") = False Then
             
            frmMain.action.AddItem "Creating Directory"
            FSO.CreateFolder (Left(ArcPath, InStrRev(ArcPath, "\")) & "\Extracted Files")
        End If
        If FSO.FolderExists(Left(ArcPath, InStrRev(ArcPath, "\")) & "\Extracted Files\" & arcname) = False Then
            FSO.CreateFolder (Left(ArcPath, InStrRev(ArcPath, "\")) & "\Extracted Files\" & arcname)
        End If
        outputPatH = Left(ArcPath, InStrRev(ArcPath, "\")) & IIf(Right(Left(ArcPath, InStrRev(ArcPath, "\")), 1) = "\", "", "\") & "Extracted Files\" & arcname
        Dim data() As Byte
         
        frmMain.action.AddItem "Reading Files"
        If filesToExtract = "" Then
            For x = 0 To UBound(fHeader)
                ReDim data(fHeader(x).FileLength)
                Get 1, , data
                Open outputPatH & "\" & fHeader(x).FileName For Binary Access Write Lock Read Write As #2
                    Put 2, , data
                Close #2
            Next x
        Else
            For x = 0 To UBound(fHeader)
                ReDim data(fHeader(x).FileLength)
                Get 1, , data
                If FileIsInList(Right(fHeader(x).FileName, Len(fHeader(x).FileName) - InStrRev(fHeader(x).FileName, "\")), filesToExtract) Then
                    Open outputPatH & "\" & fHeader(x).FileName For Binary Access Write Lock Read Write As #2
                        Put 2, , data
                    Close #2
                End If
            Next x
        End If
    Close #1
     
    frmMain.action.AddItem "Deleting Temporary Files"
     
    frmMain.action.AddItem "-------End of Report-------"""
    
End Function

Private Function FileIsInList(FiletoFind As String, List As String) As Boolean
    On Error GoTo 0
    If InStr(1, List, FiletoFind, vbTextCompare) <> 0 Then
        FileIsInList = True
    Else
        FileIsInList = False
    End If
End Function

Public Function GetFiles(ArcPath As String) As String
    Dim FSO As New FileSystemObject
    Temp = Left(ArcPath, Len(ArcPath) - 4)
     
    Open ArcPath For Binary Access Read Lock Read Write As #1
        Dim MainHeader As Archeader
        Get #1, , MainHeader
        If MainHeader.Version <> "ARC 5" Then
            MsgBox "Cannot open the file, either it has been corrupted or is the wrong format.", vbOKOnly, "Invalid File"
            frmMain.action.Clear
            frmMain.action.AddItem "Extracting File Failed Due To Invalid File Format"
            Exit Function
        End If
        Dim curFile() As FileHeader
        ReDim curFile(MainHeader.NumberOfFiles)
        For x = 0 To UBound(curFile) - 1
            Get #1, , curFile(x)
            Dim name As String
            If retfiles = "" Then
                retfiles = curFile(x).FileName
            Else
                retfiles = retfiles & Chr(0) & curFile(x).FileName
            End If
        Next x
        GetFiles = retfiles
End Function

Private Sub Copy(original As String, newName As String)
    Open original For Binary Access Read Lock Read Write As #3
        Dim data() As Byte
        ReDim data(LOF(3))
        Get #3, , data()
    Close #3
    Open newName For Binary Access Write Lock Read Write As #3
        Put #3, , data()
    Close #3
End Sub

Public Function GetValidityKey(ArcPath As String) As String
    Dim enc As New clsBlowfish
    Dim MainHeader As Archeader
    Open ArcPath For Binary Access Read Lock Read Write As #1
        Get #1, , MainHeader
    Close
    GetValidityKey = enc.DecryptString(MainHeader.validity)
End Function

Public Function GetPassword(ArcPath As String) As String
    Dim enc As New clsBlowfish
    Dim MainHeader As Archeader
    Open ArcPath For Binary Access Read Lock Read Write As #1
        Get #1, , MainHeader
    Close
    If MainHeader.Passworded Then
        GetPassword = enc.DecryptString(MainHeader.password)
    Else
        GetPassword = ""
    End If
End Function
