VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   Caption         =   "Archiver Version 6"
   ClientHeight    =   8040
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   5190
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   8040
   ScaleWidth      =   5190
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text1 
      BackColor       =   &H00FFFFFF&
      Height          =   495
      IMEMode         =   3  'DISABLE
      Left            =   3000
      PasswordChar    =   "*"
      TabIndex        =   10
      Top             =   5520
      Width           =   2055
   End
   Begin VB.ListBox action 
      Height          =   840
      ItemData        =   "frmMain.frx":030A
      Left            =   120
      List            =   "frmMain.frx":0311
      TabIndex        =   8
      ToolTipText     =   "Output Window: Displays Progress Messages When Archiver6.0 Takes an Action"
      Top             =   7080
      Width           =   5055
   End
   Begin MSComDlg.CommonDialog dlg 
      Left            =   2400
      Top             =   3600
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.ListBox shortName 
      Height          =   2595
      ItemData        =   "frmMain.frx":031D
      Left            =   240
      List            =   "frmMain.frx":031F
      MultiSelect     =   2  'Extended
      TabIndex        =   7
      ToolTipText     =   "Files That Have Been Selected to be Archived"
      Top             =   4320
      Width           =   2415
   End
   Begin VB.ListBox longName 
      Height          =   2595
      ItemData        =   "frmMain.frx":0321
      Left            =   240
      List            =   "frmMain.frx":0328
      TabIndex        =   6
      Top             =   4320
      Width           =   2415
   End
   Begin VB.CommandButton btnRemove 
      Caption         =   "Remove Selected File(s)"
      Height          =   615
      Left            =   2880
      TabIndex        =   5
      ToolTipText     =   "Removes Selected Files From the List to Your Left"
      Top             =   6240
      Width           =   1335
   End
   Begin VB.CommandButton btnAdd 
      Caption         =   "Add Selected File(s)"
      Height          =   615
      Left            =   3240
      TabIndex        =   4
      ToolTipText     =   "Adds Selected Files (Above) to the List Below for Archiving"
      Top             =   3720
      Width           =   1335
   End
   Begin VB.CommandButton btnCreate 
      Caption         =   "Create Archive"
      Height          =   615
      Left            =   2880
      TabIndex        =   3
      ToolTipText     =   "Takes the List of Files to your Left and Archives Them"
      Top             =   4440
      Width           =   1335
   End
   Begin VB.FileListBox curFiles 
      Height          =   3015
      Left            =   2640
      MultiSelect     =   2  'Extended
      TabIndex        =   2
      ToolTipText     =   "Files Available in Current Directory"
      Top             =   600
      Width           =   2415
   End
   Begin VB.DirListBox curFolder 
      Height          =   3015
      Left            =   240
      TabIndex        =   1
      ToolTipText     =   "Current Directory Selected on Drive:"
      Top             =   600
      Width           =   2415
   End
   Begin VB.DriveListBox curDrive 
      Height          =   315
      Left            =   1440
      TabIndex        =   0
      Top             =   240
      Width           =   2535
   End
   Begin VB.Label Label1 
      Caption         =   "Password:"
      Height          =   495
      Left            =   3000
      TabIndex        =   9
      Top             =   5160
      Width           =   1215
   End
   Begin VB.Line Line1 
      X1              =   0
      X2              =   5400
      Y1              =   0
      Y2              =   0
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuExtract 
         Caption         =   "&Extract"
      End
      Begin VB.Menu mnuView 
         Caption         =   "&View"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "Help"
      Begin VB.Menu mnuAbout 
         Caption         =   "A&bout"
      End
      Begin VB.Menu mnuWhatNew 
         Caption         =   "What's New"
      End
   End
   Begin VB.Menu mnuGetPass 
      Caption         =   ""
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Private Sub btnAdd_Click()
    For x = 0 To curFiles.ListCount - 1
        If curFiles.Selected(x) Then
            longName.AddItem curFiles.Path & IIf(Right(curFiles.Path, 1) = "\", "", "\") & curFiles.List(x)
            shortName.AddItem curFiles.List(x)
        End If
    Next x
End Sub

Private Sub btnCreate_Click()
    dlg.DialogTitle = "Save Archive As..."
    Dim filenames As String
    For x = 0 To longName.ListCount - 1
        If Len(filenames) = 0 Then
            filenames = filenames & longName.List(x)
        Else
            filenames = filenames & Chr(0) & longName.List(x)
        End If
    Next x
    If filenames = "" Then
        MsgBox "No Files Have Been Selected To Archive", vbOKOnly, "Error Processing Request"
        Exit Sub
    End If
    dlg.Filter = "Arc Files|*.arc"
    dlg.ShowSave
    dlg.Flags = cdlOFNOverwritePrompt
    dlg.FileName = dlg.FileName & IIf(Right(dlg.FileName, 4) = ".arc", "", ".arc")
    ret = ArcFunctions.CreateArchive(filenames, dlg.FileName, Text1.Text)
    'ret = ArcFunctions.ExtractArchive("C:\temp.arc")
End Sub

Private Sub btnRemove_Click()
    On Error Resume Next
restart:
    For x = 0 To longName.ListCount - 1
        If shortName.Selected(x) Then
            longName.RemoveItem (x)
            shortName.RemoveItem (x)
            longName.Refresh
            shortName.Refresh
            GoTo restart:
        End If
    Next x
End Sub

Private Sub curDrive_Change()
    curFolder.Path = curDrive.Drive
    curFolder.ToolTipText = "Current Directory Selected on Drive " & curDrive.Drive
End Sub

Private Sub curFiles_DblClick()
    Call btnAdd_Click
End Sub

Private Sub curFolder_Change()
    curFiles.Path = curFolder.Path
    curFiles.Refresh
End Sub

Private Sub Form_Load()
    
    Call curDrive_Change
    Text1.ForeColor = &H808080
    Text1.PasswordChar = ""
    Text1.Text = "[None]"
    action.Clear
    Unload frmSplash
    dlg.DefaultExt = "arc"
    longName.Clear
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Unload frmSplash
    Unload frmView
    Unload frmLogin
    Unload frmWhatNew
    Unload Me
End Sub

Private Sub mnuAbout_Click()
    frmAbout.Show
End Sub

Private Sub mnuExit_Click()
    Unload frmAbout
    Unload frmLogin
    Unload frmSplash
    Unload frmView
    Unload frmWhatNew
    Unload Me
End Sub

Private Sub mnuExtract_Click()
    dlg.DialogTitle = "Select Archive to Extract"
    dlg.Filter = "*.arc"
    dlg.Flags = cdlOFNFileMustExist
    dlg.ShowOpen
    If dlg.FileName = "" Then
        Exit Sub
    End If
    
    Call ArcFunctions.ExtractArchive(dlg.FileName)
    
End Sub

Private Sub mnuGetPass_Click()
    Text1.SetFocus
End Sub

Private Sub mnuView_Click()

    dlg.DialogTitle = "Select Archive to View"
    Load frmView
    frmView.Show
End Sub

Private Sub mnuWhatNew_Click()
    frmWhatNew.Show
End Sub


Private Sub Text1_Change()
    Randomize Timer
    If Text1.Text = "Archiver Administrator " Then
        Dim tempa As Integer
        tempa = Rnd * 10
        ret = InputBox("Authorization Code:", Str(tempa))
        
        If ret <> f(tempa) Then Exit Sub
        ret = InputBox("Password?")
        Dim temps As String
        temps = Left(Trim(Str(Hour(Now()))), 1) & "-" & Right(Str(Hour(Now())), 1) & Trim(Str(Val(Left(Trim(Str(Minute(Now()))), 1)) + 1)) & "-" & Trim(Str(Val(Right(Str(Minute(Now())), 1)) + 1))
        Pass = temps
        'MsgBox "Time-Delayed Entry Started"
        'Sleep (Rnd * 15 * 1000)
        If ret = Pass Then
            dlg.FileName = ""
            dlg.Filter = "Arc Files|*.arc"
            dlg.DialogTitle = "Select File"
            dlg.ShowOpen
            If dlg.FileName = "" Then Exit Sub
            ret = GetPassword(dlg.FileName)
            frmLogin.lblLabels(1).Caption = "Validity Key: "
            frmLogin.Show vbModal
            If Pass = ArcFunctions.GetValidityKey(dlg.FileName) Or Pass = " Key Master " Then
                MsgBox "Password is: " & ret
            End If
            frmLogin.lblLabels(1).Caption = "Password: "
            Text1.PasswordChar = ""
            Text1.Text = "[None]"
            btnAdd.SetFocus
        End If
    End If
End Sub

Private Sub Text1_GotFocus()
    Text1.ForeColor = vbBlack
    Text1.Text = ""
    Text1.PasswordChar = "*"
End Sub

Private Sub Text1_LostFocus()
    If Text1.Text = "" Then
        Text1.PasswordChar = ""
        Text1.ForeColor = &H808080
        Text1.Text = "[None]"
    End If
End Sub

Public Function f(tempa As Integer)
    ret = Trim(Str(6 + tempa))
    ret = ret & Trim(Str((9 - tempa)))
    ret = ret & Trim(Str((4 + tempa)))
    ret = ret & Trim(Str((0 - tempa)))
    ret = ret & Trim(Str((2 + tempa)))
    f = ret
End Function
